/// <reference types="express" />
import { Application as ExpressApp } from 'express';
import { Injector } from '../core/injector';
import { ServerMetadataT } from '../metadata/server/server-t';
export declare class Server {
    private _origMeta;
    constructor(_origMeta: ServerMetadataT);
    readonly originalMeta: ServerMetadataT;
    private _loggerCore;
    private readonly logger;
    private _app;
    readonly app: ExpressApp;
    private _injector;
    readonly injector: Injector;
    init(): Promise<void>;
    initImpl(): Promise<void>;
    private initPromise;
    startTime: Date | null;
    errorCode: number;
    private onSIGINT();
    shutdown(): Promise<void>;
    createExpressApp(): void;
    private serviceReflector;
    initOrm(): Promise<void>;
    private startServices();
    private listenServices();
    private stopServices();
    private routerReflector;
    private reflectRoutes();
    private webServer;
    private listen();
    private stopListening();
    private onError(error);
    private onListening();
}
